<template>
  <div>
    <div class="my-4">
      <h4 class="mt-0 mb-3">Forgot your password</h4>
      <p class="text-muted mb-0 font-13" v-if="!emailSent">
        Enter your email address and we'll send you an email with instructions
        on how to reset your password.
      </p>
    </div>

    <form @submit.prevent="sendPasswordResetMail">
      <div id="error-message" v-if="errors.serverSideErrorMessage">
        <span>
          {{ errors.serverSideErrorMessage }}
        </span>
      </div>

      <template v-if="!emailSent">
        <div class="form-group mb-3">
          <label for="emailaddress">E-mail addresse</label>
          <input
            id="emailaddress"
            class="form-control"
            type="email"
            placeholder="Entrer your E-mail addresse"
            v-model="credential.email"
            required
          />
          <span class="text-danger" v-if="errors.emailErrorMessage">
            {{ errors.emailErrorMessage }}
          </span>
        </div>

        <div class="form-group mb-3">
          Back to
          <router-link :to="{ name: 'Login' }" class="text-muted ml-1"
            >Login</router-link
          >
        </div>

        <div class="form-group mb-0 text-center">
          <button
            class="btn btn-primary btn-block btn-submit w-100"
            type="submit"
            :disabled="submitting"
          >
            Submit
          </button>
        </div>
      </template>

      <template v-else>
        <div class="mb-3" v-if="!submitting">
          You will soon receive an email with instructions to reset your
          password.
        </div>

        <div class="form-group mb-0 text-center">
          <button
            class="btn btn-primary btn-block btn-submit w-100"
            type="submit"
            :disabled="submitting"
          >
            Resend again
          </button>
        </div>
      </template>
    </form>
  </div>
</template>

<script>
import { EVENT_MANAGER_APP_BASE_URL } from "@/configs";

export default {
  name: "forgot-password-page",
  data: () => ({
    submitting: false,
    emailSent: false,
    credential: {
      email: null,
      redirectLink: null,
    },
    errors: {
      emailErrorMessage: null,
      serverSideErrorMessage: null,
    },
  }),
  methods: {
    clearForm() {
      this.credential.email = null;
    },
    clearErrorsMessages() {
      this.errors.emailErrorMessage = null;
      this.errors.serverSideErrorMessage = null;
    },
    async sendPasswordResetMail() {
      this.clearErrorsMessages();

      this.submitting = true;
      this.$services.AuthService.sendPasswordResetMail(this.credential)
        .then(() => {
          this.emailSent = true;
          this.submitting = false;
        })
        .catch((err) => {
          if (err.response.status === 403) {
            this.errors.serverSideErrorMessage = err.response.data.message;
          } else if (err.response.status === 422) {
            for (const error of err.response.data.data) {
              if (error.field == "email") {
                this.errors.emailErrorMessage = error.message;
              }
            }
          } else {
            this.errors.serverSideErrorMessage =
              "Something went wrong. Please try again later!";
          }
          this.submitting = false;
        });
    },
  },
  created() {
    const allRoutes = this.$router.getRoutes();
    this.redirectLink = `${
      EVENT_MANAGER_APP_BASE_URL +
      "" +
      allRoutes.find((route) => route.name == "ResetPassword").path
    }`;
  },
};
</script>

<style>
</style>